package com.nantian.cloud.jljc.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.nantian.cloud.jljc.entity.DictEnterpriseType1998;
import com.nantian.cloud.jljc.service.DictEnterpriseType1998Service;
import com.nantian.sc.cloud.common.core.util.R;
import com.nantian.sc.cloud.common.log.annotation.SysLog;
import com.nantian.sc.cloud.common.security.service.ScUser;
import com.nantian.sc.cloud.common.security.util.SecurityUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.util.Date;


/**
 * 企业类型
 *
 * @author
 * @date 2020-08-14
 */
@CrossOrigin
@RestController
@AllArgsConstructor
@RequestMapping("/dictEnterpriseType1998")
@Api(value="dictEnterpriseType1998",tags = "企业类型1998")
public class DictEnterpriseType1998Controller {
	private final DictEnterpriseType1998Service DictEnterpriseType1998Service;


	/**
	 * 分页查询
	 *
	 * @param page      分页对象
	 * @param dictEnterpriseType1998
	 * @return
	 */
	@GetMapping("/page")
	@ApiOperation(value = "分页获取企业类型", notes = "分页获取企业类型")
	@ApiImplicitParams({
			@ApiImplicitParam(name = "page", value = "分页对象", required = false, dataType = "json", paramType = "path"),
			@ApiImplicitParam(name = "dictEnterpriseType1998", value = "企业类型对象", required = false, dataType = "json", paramType = "path")
	})
	public R getAdvancedMaterialPage(Page page, DictEnterpriseType1998 dictEnterpriseType1998) {
		dictEnterpriseType1998.setDelFlag("1"); //查询为删除数据
		return R.ok(DictEnterpriseType1998Service.page(page, Wrappers.query(dictEnterpriseType1998)));
	}


	/**
	 * 信息
	 *
	 * @param dictEnterpriseType1998Id
	 * @return R
	 */
	@GetMapping("/{dictEnterpriseType1998Id}")
	@ApiOperation(value = "根据id获取企业类型", notes = "根据id获取企业类型")
	@ApiImplicitParam(name = "dictEnterpriseType1998Id", value = "id", required = true, dataType = "int", paramType = "path")
	public R getById(@PathVariable("dictEnterpriseType1998Id") Integer  dictEnterpriseType1998Id) {
		return R.ok(DictEnterpriseType1998Service.getById(dictEnterpriseType1998Id));
	}

	/**
	 * 保存
	 *
	 * @param dictEnterpriseType1998
	 * @return R
	 */
	@PostMapping
	@SysLog("新增企业类型")
	@ApiOperation(value = "新增企业类型", notes = "新增企业类型")
	@ApiImplicitParam(name = "DictEnterpriseType1998", value = "企业类型对象", required = true, dataType = "json", paramType = "path")
	public R save(@RequestBody DictEnterpriseType1998 dictEnterpriseType1998) {
		ScUser u= SecurityUtils.getUser();
		dictEnterpriseType1998.setUserid(u.getId());
		dictEnterpriseType1998.setDeptId(u.getDeptId());
		dictEnterpriseType1998.setUpdateTime(new Date());
		dictEnterpriseType1998.setDelFlag("1");
		return R.ok(DictEnterpriseType1998Service.save(dictEnterpriseType1998));
	}

	/**
	 * 修改
	 *
	 * @param dictEnterpriseType1998
	 * @return R
	 */
	@PutMapping
	@SysLog("修改企业类型")
	@ApiOperation(value = "修改企业类型", notes = "修改企业类型")
	@ApiImplicitParam(name = "DictEnterpriseType1998", value = "企业类型对象", required = true, dataType = "json", paramType = "path")
	public R updateById(@RequestBody DictEnterpriseType1998 dictEnterpriseType1998) {
		ScUser u= SecurityUtils.getUser();
		dictEnterpriseType1998.setUserid(u.getId());
		dictEnterpriseType1998.setUpdateTime(new Date());
		return R.ok(DictEnterpriseType1998Service.updateById(dictEnterpriseType1998));
	}

	/**
	 * 删除
	 *
	 * @param dictEnterpriseType1998Id
	 * @return R
	 */
	@DeleteMapping("/{dictEnterpriseType1998Id}")
	@SysLog("删除企业类型")
	@ApiOperation(value = "删除企业类型", notes = "删除企业类型")
	@ApiImplicitParam(name = "dictEnterpriseType1998Id", value = "id", required = true, dataType = "int", paramType = "path")
	public R removeById(@PathVariable Integer dictEnterpriseType1998Id) {
		DictEnterpriseType1998 dictEnterpriseType1998 = DictEnterpriseType1998Service.getById(dictEnterpriseType1998Id);
		if(dictEnterpriseType1998==null){
			return R.failed("企业类型不存在，删除失败！");
		}
		ScUser u= SecurityUtils.getUser();
		dictEnterpriseType1998.setUserid(u.getId());
		dictEnterpriseType1998.setUpdateTime(new Date());
		dictEnterpriseType1998.setDelFlag("4");
		return R.ok(DictEnterpriseType1998Service.updateById(dictEnterpriseType1998));
	}

}
